﻿CREATE TABLE methods(
        method_index SERIAL,
        method CHARACTER VARYING,
        CONSTRAINT methods_pkey PRIMARY KEY (method_index)
);

INSERT INTO methods (method) VALUES ('GET');
INSERT INTO methods (method) VALUES ('POST');
INSERT INTO methods (method) VALUES ('PUT');
INSERT INTO methods (method) VALUES ('DELETE');
INSERT INTO methods (method) VALUES ('HEAD');

CREATE TABLE page_views(
        page_view_index SERIAL,
        page CHARACTER VARYING(256),
        view_time TIMESTAMP,
        load_time INTERVAL,
        method_index INTEGER,
        remote_address INET,
        user_agent CHARACTER VARYING(512),
        CONSTRAINT page_views_pkey PRIMARY KEY (page_view_index),
        CONSTRAINT method_index_fkey FOREIGN KEY (method_index)
		REFERENCES methods (method_index) 
);

