﻿CREATE OR REPLACE FUNCTION refresh_report_row() RETURNS TRIGGER
LANGUAGE plpgsql
AS $$
BEGIN
	DELETE FROM 
		report_mv 
	WHERE 
		view_date=NEW.view_time::DATE AND
		page=NEW.page AND
		method_index=NEW.method_index;
		
	INSERT INTO 
		report_mv
	SELECT 
		view_time::DATE AS view_date,
		page,
		method_index,
		COUNT(*) AS total,
		AVG(load_time) AS load_time	
	FROM
		page_views
	WHERE
		page=NEW.page AND
		view_time::DATE=NEW.view_time::DATE AND
		method_index=NEW.method_index
	GROUP BY
		page,view_time::DATE,method_index;
	RETURN NULL;
END;
$$;

--DROP TRIGGER page_views_insert ON page_views;

CREATE TRIGGER page_views_insert AFTER INSERT
   ON page_views FOR EACH ROW
   EXECUTE PROCEDURE public.refresh_report_row();