﻿CREATE OR REPLACE FUNCTION report_row_delete() RETURNS TRIGGER
LANGUAGE plpgsql
AS $$
DECLARE
	old_total INTEGER;
BEGIN
	SELECT 
		total INTO old_total
	FROM
		report_mv
	WHERE
		page=OLD.page AND
		view_date=OLD.view_time::DATE AND
		method_index=OLD.method_index;
	IF old_total=1 THEN
		DELETE FROM 
			report_mv
		WHERE
			page=OLD.page AND
			view_date=OLD.view_time::DATE AND
			method_index=OLD.method_index;
	ELSE
		UPDATE
			report_mv
		SET
			load_time=((load_time*total)-OLD.load_time)/(total-1),
			total=total-1
		WHERE
			page=OLD.page AND
			view_date=OLD.view_time::DATE AND
			method_index=OLD.method_index;
	END IF;
	RETURN NULL;
END;
$$;

CREATE TRIGGER page_views_delete AFTER DELETE
   ON page_views FOR EACH ROW
   EXECUTE PROCEDURE public.report_row_delete();